// SoundSpeed_BT_2021
// IDE 1.8.5
// Adapted and modified by Alberto Villalobos (IDE 1.8.5)
//
// Basic Bluetooth sketch HC-06_01
// Connect the HC-06 module and communicate using the serial monitor
// The HC-06 defaults to AT mode when first powered on.
// The default baud rate is 9600
// The HC-06 requires all AT commands to be in uppercase. NL+CR should not be added to the command string
//
// Ultrasonic Sensor HC-SR04 and Arduino Tutorial
// Crated by Dejan Nedelkovski,
// www.HowToMechatronics.com

#include <SoftwareSerial.h>
SoftwareSerial BTserial(2, 3); // RX | TX
// Connect the HC-06 TX to the Arduino RX on pin 2. 
// Connect the HC-06 RX to the Arduino TX on pin 3 through a voltage divider.

float duration;

// defines pins numbers

const int trigPin = 9;
const int echoPin = 10;

//TMP36 Pin Variables

int sensorPin = 0; //the analog pin the TMP36's Vout (sense) pin is connected to
                   //the resolution is 10 mV / degree centigrade with a
                   //500 mV offset to allow for negative temperatures
float Temperatura;
float CorrecTemp = -4; //Corrección a la temperatura medida inicialmente por el sensor
 
void setup() {
  
pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
pinMode(echoPin, INPUT); // Sets the echoPin as an Input

Serial.begin(9600);
    
BTserial.begin(9600); // HC-06 default serial speed is 9600
}
 
void loop()
{ 
  
 int reading = analogRead(sensorPin);  
 
 // converting that reading to voltage, for 3.3v arduino use 3.3
 
 float voltage = reading * 5.0/1024;
 
 float temperatureC = (voltage - 0.5) * 100 ;  //converting from 10 mv per degree wit 500 mV offset
                                               //to degrees ((voltage - 500mV) times 100)
 Temperatura = temperatureC + CorrecTemp;
 
 // Clears the trigPin
 
digitalWrite(trigPin, LOW);
delayMicroseconds(2);

// Sets the trigPin on HIGH state for 10 micro seconds

digitalWrite(trigPin, HIGH);
delayMicroseconds(10);
digitalWrite(trigPin, LOW);

// Reads the echoPin, returns the sound wave travel time in microseconds

duration = pulseIn(echoPin, HIGH);

// Imprimir las mediciones a Monitor Serial

BTserial.print("<");
BTserial.print(duration);BTserial.print(" ");
BTserial.print(Temperatura);BTserial.print(" ");
BTserial.println(">");

delay(950); // Esta velocidad debe ser menor o igual a la velocidad del reloj del bluetooth en App Inventor 2

}

